AppDomain.FirstChanceException イベント

定義

アプリケーション ドメイン内の例外ハンドラーに対する呼び出し履歴をランタイムが検索する前に、マネージド コード内で例外がスローされた場合に発生します。Occurs when an exception is thrown in managed code, before the runtime searches the call stack for an exception handler in the application domain.

public:
 event EventHandler<System::Runtime::ExceptionServices::FirstChanceExceptionEventArgs ^> ^ FirstChanceException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> FirstChanceException;
member this.FirstChanceException : EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> 
Public Custom Event FirstChanceException As EventHandler(Of FirstChanceExceptionEventArgs) 
属性

次の例では、AD3を通じて AD0 という名前の一連のアプリケーションドメインを作成し、各アプリケーションドメインに Worker オブジェクトを作成します。The following example creates a series of application domains named AD0 through AD3, with a Worker object in each application domain. Worker オブジェクトには、最後のアプリケーションドメインの Worker を除き、次のアプリケーションドメインの Worker オブジェクトへの参照があります。Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. FirstChanceException イベントは、AD1を除くすべてのアプリケーションドメインで処理されます。The FirstChanceException event is handled in all application domains except AD1.

注意

次の例では、複数のアプリケーションドメインでの初回例外通知を示していますが、単純なユースケースについては 「」を参照してください。初回例外通知受け取ります。In addition to this example, which demonstrates first-chance exception notifications in multiple application domains, you can find simple use cases in How to: Receive First-Chance Exception Notifications.

アプリケーションドメインが作成されると、既定のアプリケーションドメインは、最初のアプリケーションドメインの TestException メソッドを呼び出します。When the application domains have been created, the default application domain calls the TestException method for the first application domain. Worker オブジェクトは、最後の Worker が処理または処理されない例外をスローするまで、次のアプリケーションドメインの TestException メソッドを呼び出します。Each Worker object calls the TestException method for the next application domain, until the last Worker throws an exception that is either handled or unhandled. したがって、現在のスレッドはすべてのアプリケーションドメインを通過し、TestException が各アプリケーションドメインのスタックに追加されます。Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

最後の Worker オブジェクトが例外を処理するとき、FirstChanceException イベントは最後のアプリケーションドメインでのみ発生します。When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. 他のアプリケーションドメインは例外を処理する機会を得られないため、イベントは発生しません。The other application domains never get a chance to handle the exception, so the event is not raised.

最後の Worker オブジェクトが例外を処理しない場合、イベントハンドラーを持つ各アプリケーションドメインで FirstChanceException イベントが発生します。When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. 各イベントハンドラーが完了すると、既定のアプリケーションドメインによって例外がキャッチされるまで、スタックは引き続きアンワインドされます。After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

注意

イベントが発生したときにスタックの表示がどのように拡大し、既定のアプリケーションドメインの近くにあるかを確認するには、e.Exception.MessageFirstChanceHandler イベントハンドラーの e.Exception に変更します。To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. TestException がアプリケーションドメインの境界を越えて呼び出されると、2回表示されることに注意してください。1回はプロキシ用、もう1回はスタブ用です。Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

注釈

このイベントは単なる通知です。This event is only a notification. このイベントを処理しても、例外は処理されず、それ以降の例外処理にも影響しません。Handling this event does not handle the exception or affect subsequent exception handling in any way. イベントが発生し、イベントハンドラーが呼び出されると、共通言語ランタイム (CLR) は例外のハンドラーの検索を開始します。After the event has been raised and event handlers have been invoked, the common language runtime (CLR) begins to search for a handler for the exception. FirstChanceException は、アプリケーションドメインにマネージ例外を最初に確認する機会を提供します。FirstChanceException provides the application domain with a first chance to examine any managed exception.

イベントは、アプリケーションドメインごとに処理できます。The event can be handled per application domain. 呼び出しの実行中にスレッドが複数のアプリケーションドメインを通過する場合、イベントは、イベントハンドラーを登録した各アプリケーションドメインで発生し、CLR がそのアプリケーションドメインで一致する例外ハンドラーの検索を開始します。If a thread passes through multiple application domains while executing a call, the event is raised in each application domain that has registered an event handler, before the CLR begins searching for a matching exception handler in that application domain. イベントが処理された後、そのアプリケーションドメイン内の一致する例外ハンドラーに対して検索が実行されます。After the event has been handled, a search is made for a matching exception handler in that application domain. 見つからない場合は、次のアプリケーションドメインでイベントが発生します。If none is found, the event is raised in the next application domain.

FirstChanceException イベントのイベントハンドラーで発生したすべての例外を処理する必要があります。You must handle all exceptions that occur in the event handler for the FirstChanceException event. それ以外の場合、FirstChanceException は再帰的に発生します。Otherwise, FirstChanceException is raised recursively. これにより、スタックオーバーフローとアプリケーションの終了が発生する可能性があります。This could result in a stack overflow and termination of the application. このイベントのイベントハンドラーは、制約された実行領域 (Cer) として実装することをお勧めします。例外通知が発生している間に、メモリ不足やスタックオーバーフローなどのインフラストラクチャ関連の例外が仮想マシンに影響を与えるのを防ぐためです。処理中です。We recommend that you implement event handlers for this event as constrained execution regions (CERs), to keep infrastructure-related exceptions such as out-of-memory or stack overflow from affecting the virtual machine while the exception notification is being processed.

このイベントは、イベントハンドラーがセキュリティクリティカルで、HandleProcessCorruptedStateExceptionsAttribute 属性を持っている場合を除き、アクセス違反などのプロセス状態の破損を示す例外に対しては発生しません。This event is not raised for exceptions that indicate corruption of process state, such as access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

共通言語ランタイムは、この通知イベントが処理されている間、スレッドの中止を中断します。The common language runtime suspends thread aborts while this notification event is being handled.

セキュリティ

SecurityCriticalAttribute
直前の呼び出し元に完全信頼が必要です。Requires full trust for the immediate caller. このメンバーは、部分的に信頼されているコードまたは透過的なコードでは使用できません。This member cannot be used by partially trusted or transparent code.

適用対象

こちらもご覧ください